<div class="modal fade" id="modal-help" tabindex="-1" role="dialog" aria-labelledby="modal-help-label" aria-hidden="true">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title" id="modal-help-label">Help</h5>
				<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			</div>
			<div class="modal-body">
				<p><b>R<span style="color:#bbb">e</span>solver</b> is a tool for automatically resolving Wikidata entity ids from a given list of search queries.</p>
				
				<h3>Syntax</h3>
				<p>The syntax of Rsolver is based on <a href="https://tools.wmflabs.org/quickstatements/" target="_blank" rel="noopener">QuickStatements v1</a>'s one and, if resolving succeeds, will be processed back to valid QuickStatements v1 statements.</p>
				<p>A simple query which consists of only one <i><a href="#help_command_lines">command line</a></i> could for example look like this:<br/>
					<code>Wikidata|P31=Q14827288<span class="highlight-tab"></span>operator|P1629=Q29933786|type=P<span class="highlight-tab"></span>Wikimedia Foundation|^enwiki|type=Q<span class="highlight-tab"></span>$P275<span class="highlight-tab"></span>$Q6938433</code>
				</p>
				<div id="help_sampletable">
					<table class="table-syntax">
						<tbody>
							<tr>
								<td><code>Wikidata</code></td>
								<td rowspan="3"><code>|</code></td>
								<td><code>P31</code></td>
								<td rowspan="2"><code>=</code></td>
								<td><code>Q14827288</code></td>
								<td rowspan="4"><code><span class="highlight-tab"></span></code></td>
								<td><code>operator</code></td>
								<td rowspan="3"><code>|</code></td>
								<td><code>P1629</code></td>
								<td rowspan="2"><code>=</code></td>
								<td><code>Q29933786</code></td>
								<td rowspan="3"><code>|</code></td>
								<td rowspan="2"><code>type</code></td>
								<td rowspan="2"><code>=</code></td>
								<td><code>P</code></td>
								<td rowspan="4"><code><span class="highlight-tab"></span></code></td>
								<td><code>Wikimedia Foundation</code></td>
								<td rowspan="3"><code>|</code></td>
								<td rowspan="2"><code>^</code></td>
								<td><code>enwiki</code></td>
								<td rowspan="3"><code>|</code></td>
								<td rowspan="2"><code>type</code></td>
								<td rowspan="2"><code>=</code></td>
								<td><code>Q</code></td>
								<td rowspan="4"><code><span class="highlight-tab"></span></code></td>
								<td><code>$P275</code></td>
								<td rowspan="4"><code><span class="highlight-tab"></span></code></td>
								<td><code>$Q6938433</code></td>
							</tr>
							<tr class="underline_row">
								<td rowspan="2">search query</td>
								<td>property</td>
								<td>value</td>
								<td rowspan="2">search query</td>
								<td>property</td>
								<td>value</td>
								<td><i><a href="#help_type_property">type</a></i></td>
								<td rowspan="2">search query</td>
								<td>wiki code</td>
								<td><i><a href="#help_type_property">type</a></i></td>
								<td rowspan="3"><i><a href="#help_literals">literal</a></i></td>
								<td rowspan="3"><i><a href="#help_literals">literal</a></i></td>
							</tr>
							<tr class="underline_row">
								<td colspan="3"><i><a href="#help_basic_conditions">basic condition</a></i></td>
								<td colspan="3"><i><a href="#help_basic_conditions">basic condition</a></i></td>
								<td colspan="3"><i><a href="#help_properties">properties</a></i></td>
								<td colspan="2"><i><a href="#help_wiki_article_name">wiki article name condition</a></i></td>
								<td colspan="3"><i><a href="#help_properties">properties</a></i></td>
							</tr>
							<tr class="underline_row">
								<td colspan="5"><i><a href="#help_resolve_tuple">resolve tuple</a></i></td>
								<td colspan="9"><i><a href="#help_resolve_tuple">resolve tuple</a></i></td>
								<td colspan="8"><i><a href="#help_resolve_tuple">resolve tuple</a></i></td>
							</tr>
							<tr class="underline_row">
									<td colspan="28"><i><a href="#help_command_lines">command line</a></i></td>
								</tr>
						</tbody>
					</table>
				</div>
				<p>By the way: <a href="#" data-bs-target="#modal-grammar" data-bs-toggle="modal" v-on:click.prevent="displayGrammar">There's a grammar</a> for those interested.</p>
				
				<h4 id="help_command_lines">Command lines</h4>
				<p>Each <b>command line</b> consists of at least one <i><a href="#help_resolve_tuple">resolve tuple</a></i> or <i><a href="#help_literals">literal</a></i>. Multiple <i>resolve tuples</i> or <i>literals</i> per command line are seperated by a single tab each.<br/>
				All resolve tuples in a command line must have been a successfully resolved in order for the whole command line to be considered resolved. Otherwise the command line will be considered as failed and is output in a separate textbox.</p>
				
				<h4 id="help_resolve_tuple">Resolve tuple</h4>
				<p>A <b>resolve tuple</b> is what actually contains your search query to resolve. It consists of at least one and up to three parts which are seperated by pipes (<code>|</code>):</p>
				<ul>
					<li>The first part of a tuple is your search query.</li>
					<li><i>Optional:</i> The second part is a list of <i><a href="#help_conditions">conditions</a></i> for the expected Wikidata entity. Multiple conditions are separated by semicolons (<code>;</code>).</li>
					<li><i>Optional:</i> The third part of a tuple is list of <a href="#help_properties">properties</a>, which basically are key-value-pairs. These can be used to finetune some settings for resolving. Multiple properties are separated by semicolons (<code>;</code>).</li>
				</ul>
				<p><i>Example:</i> <code>Wikidata|P31=Q14827288|type=Q</code>, <code>Wikidata|P31=Q14827288</code>, <code>Wikidata||type=Q</code>, <code>Wikidata</code></p>

				<h4 id="help_literals">Literals</h4>
				<p>A <b>literal</b> is a string which will not be processed but output. These might come in handy for generating QuickStatements. A literal starts with a dollar sign (<code>$</code>) and is followed by the text.<br/>
					<i>Example:</i> <code>$Wikidata</code>, <code>$P31</code></p>
				
				<h4 id="help_conditions">Conditions</h4>
				<p><b>Conditions</b> define which items to automatically ignore. A condition consists of a property and a value seperated by a command-character specific to each condition type. Multiple conditions which all have to be fullfilled (AND) can be specified by seperating them with semicolons (<code>;</code>).</p>
				
				<h5 id="help_basic_conditions">Basic conditions <code>=</code></h5>
				<p>A <b>basic condition</b> consists of a property and a value seperated by an "equals to"-character (<code>=</code>). A candidate is required to have the property and value for the property as defined in the condition. This condition does not check for transitive properties meaning a candidate must explicitly have the given statement.<br/>
					<i>Example:</i> <code>Wikidata|P275=Q6938433</code>, <code>Wikidata|P275=Q6938433;P31=Q35127</code></p>

				<h5 id="help_basic_conditions_transitive">Basic conditions - Transitive <code>*=</code></h5>
				<p>A <b>basic condition</b> can be extended to check for transitive properties by appending an "asterisk"-character (<code>*</code>) to the property.<br/>
					<i>Example:</i> <code>Treptow-Köpenick|P131*=Q183</code></p>

				<h5 id="help_wiki_article_name">Wiki article name <code>^</code></h5>
				<p>This condition can be used to extract the associated Wikidata id from a given wiki article. A list of all wiki abbreviations can be found <a href="https://www.wikidata.org/w/api.php?action=help&amp;modules=wbgetentities" target="_blank" rel="noopener">here</a> next to "Sites". Please note that currently this condition  cannot be combined with other conditions!<br/>
					<i>Example:</i> <code>Platooning|^enwiki</code></p>

				<h5 id="help_spaql_conditions">SPARQL conditions <code>~</code></h5>
				<p>A <b>SPARQL condition</b> consists of a property and a value seperated by a "tilde"-character (<code>~</code>). They are the most versatile type of conditions and will be set together to <code>?item <i>&lt;property&gt;</i> <i>&lt;value&gt;</i> .</code>. Please note that SPARQL prefixes like "wdt" and "wd" are required.<br/>
					<i>Example:</i> Filter organs - <code>Heart|wdt:P31/wdt:P279*~wd:Q712378</code></p>
				<p>Useful combinations:</p>
				<ul>
					<li><code>wdt:P31/wdt:P279*~</code>, instance of/subclass of*</li>
				</ul>

				<h4 id="help_properties">Properties</h4>
				<table class="table table-striped">
					<thead>
						<tr>
							<th scope="col">Property</th>
							<th scope="col">Description</th>
							<th scope="col">Default value</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<th id="help_note_property" scope="row"><code>note</code></th>
							<td>A note which is displayed in the data table.</td>
							<td><i>unset</i></td>
						</tr>
						<tr>
							<th id="help_type_property" scope="row"><code>type</code></th>
							<td>The type of entity you want to resolve. For example <code>item</code>, <code>lexeme</code> or <code>property</code>.</td>
							<td><code>item</code></td>
						</tr>
					</tbody>
				</table>

				<h4 id="help_url_parameters">URL parameters</h4>
				<p>Rsolver accepts some url parameters (as part of the so called query string) to quickly apply settings.</p>
				<table class="table table-striped">
					<thead>
						<tr>
							<th scope="col">Parameter</th>
							<th scope="col">Description</th>
							<th scope="col">Default value</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<th id="help_settings_urlparameter" scope="row"><code>settings</code></th>
							<td>A JSON-encoded object of properties. A URL containing this parameter is generated when clicking on <i>Get URL</i> in the settings dialog window.</td>
							<td><i>unset</i></td>
						</tr>
					</tbody>
				</table>

				<h4 id="help_interfacing">Interfacing</h4>
				<p>Using <code>postMessage</code>s other applications can easily interface with Rsolver.</p>
				
				<h5 id="help_interfacing_outputpiping">Output piping</h5>
				<p>By registering an <em>output pipe</em> other applications can request Rsolver to forward generated outputs.</p>

				<ul>
					<li>Send <code>{'type': 'outputPipeEnable'}</code> via <code>postMessage</code></li>
					<li>Rsolver will reply with <code>{'type': 'resolver.outputPipeRegistered'}</code></li>
					<li>Now, every time output is generated Rsolver will send a <code>postMessage</code> with <code>{'type': 'rsolver.outputPipe', 'data': {'success': '⟨QuickStatements separated by newlines⟩', 'failed': '⟨QuickStatements separated by newlines⟩'}}</code></li>
				</ul>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-primary" data-bs-dismiss="modal">Close</button>
			</div>
		</div>
	</div>
</div>
